/*----------------------------------------------------------------------------------------------------------

	  .-,.-.,-. )\.---.  .')      .')     )\    /(
	  ).-, ,-.((   ,-._(( /      ( /      \ (_.' /
	      ))    \  '-,   ))       ))       )  _.'
	 .-._((      ) ,-`   )'._.-.  )'._.-.  / /
	(      )    (  ``-. (       )(       )(  \
	 '._.\(      )..-.(  )/,__.'  )/,__.'  ).'

							     .'(   .-./(   /`-.  .')        )\.-.
							 ,') \  ),'     ),' _  \( /       ,'     )
							(  /(/ /(  .-, ((  '-' ( ))      (  .-, (
							 )    (  ) '._\ )) ,_ .' )'._.-.  ) '._\ )
							(  .'\ \(  ,   ((  ' ) \(       )(  ,   (
							 )/   )/ )/ ._.' )/   )/ )/,__.'  )/ ._.'

												Ver. 5.1

A Minecraft shaderpack that makes the whole world shake and wobble like jelly. Beware of any possible motion
sickness!

This shaderpack requires OptiFine; download and run OptiFine at least once, then put this shaderpack into
the shaderpacks folder.
You can find OptiFine here: http://optifine.net/home

Created by Beed28
Official forum topic: http://www.minecraftforum.net/forums/mapping-and-modding/minecraft-mods/1290502/
----------------------------------------------------------------------------------------------------------*/

#version 120

uniform sampler2D texture;
uniform sampler2D lightmap;

varying vec4 color;
varying vec4 texcoord;
varying vec4 lmcoord;
uniform vec4 entityColor;

const int GL_LINEAR = 9729;
const int GL_EXP = 2048;

uniform int fogMode;

void main() {

	gl_FragData[0] = mix((texture2D(texture, texcoord.xy) * texture2D(lightmap, lmcoord.xy) * color), entityColor, vec4(entityColor.aaa, 0));
	gl_FragData[1] = vec4(vec3(gl_FragCoord.z), 1.0);
		
	if (fogMode == GL_EXP) {
		gl_FragData[0].rgb = mix(gl_FragData[0].rgb, gl_Fog.color.rgb, 1.0 - clamp(exp(-gl_Fog.density * gl_FogFragCoord), 0.0, 1.0));
	} else if (fogMode == GL_LINEAR) {
		gl_FragData[0].rgb = mix(gl_FragData[0].rgb, gl_Fog.color.rgb, clamp((gl_FogFragCoord - gl_Fog.start) * gl_Fog.scale, 0.0, 1.0));
	}
}